# coding: utf-8

"""
    HiddenLayer ModelScan

    HiddenLayer ModelScan API for scanning of models

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class SubmissionV2(BaseModel):
    """
    SubmissionV2
    """ # noqa: E501
    metadata: Optional[Dict[str, Any]] = None
    tags: Optional[List[StrictStr]] = None
    sensor_id: StrictStr
    requester_id: Optional[StrictStr] = 'UNKNOWN'
    input_layer: StrictStr
    input_layer_dtype: StrictStr
    input_layer_shape: List[Union[StrictFloat, StrictInt]]
    output_layer: StrictStr
    output_layer_dtype: StrictStr
    output_layer_shape: List[Union[StrictFloat, StrictInt]]
    predictions: Optional[List[Union[StrictFloat, StrictInt]]] = None
    event_time: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["metadata", "tags", "sensor_id", "requester_id", "input_layer", "input_layer_dtype", "input_layer_shape", "output_layer", "output_layer_dtype", "output_layer_shape", "predictions", "event_time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubmissionV2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubmissionV2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "metadata": obj.get("metadata"),
            "tags": obj.get("tags"),
            "sensor_id": obj.get("sensor_id"),
            "requester_id": obj.get("requester_id") if obj.get("requester_id") is not None else 'UNKNOWN',
            "input_layer": obj.get("input_layer"),
            "input_layer_dtype": obj.get("input_layer_dtype"),
            "input_layer_shape": obj.get("input_layer_shape"),
            "output_layer": obj.get("output_layer"),
            "output_layer_dtype": obj.get("output_layer_dtype"),
            "output_layer_shape": obj.get("output_layer_shape"),
            "predictions": obj.get("predictions"),
            "event_time": obj.get("event_time")
        })
        return _obj


